/*global FARR, dan */
var displayname = "Akete",
    versionstring = "1.0.1.1",
    releasedatestring = "Dec 25th, 2008",
    author = "ewemoa",
    updateurl = "",
    homepageurl = "",
    shortdescription = "Akete",
    longdescription = "FARR-specific file associations",
    advconfigstring = "",
    readmestring = "FScript",
    iconfilename = "Akete.ico",
    //
    aliasstr = "",
    regexstr = "",
    regexfilterstr = "",
    keywordstr = "",
    scorestr = "";
// SEE THE BOTTOM OF THE FILE FOR MAKING GLOBAL ENTRY POINTS
//
// dan - (d)estructuring (a)ssignment (n)eeded :)
// XXX: why the parens surrounding the function () { ... } below?
//           seems to help notepad++'s Function List plugin
// XXX: dan is not preceded by 'var' because then delete will fail...
dan = (function () {
      // emitResult() / onProcessTrigger() types
  var UNKNOWN = 0, FILE = 1, FOLDER = 2, ALIAS = 3, URL = 4, 
      PLUGIN = 5, CLIP = 6, ALIASFILE = 7,
      // postprocessing for emitResult()
      IMMEDIATE_DISPLAY = 0, ADD_SCORE = 1, MATCH_AGAINST_SEARCH = 2,
      // search state
      STOPPED = 0, SEARCHING = 1,
      // trigger result,
      TRIGGER_HANDLED = 1, TRIGGER_CLOSE = 2,
      // trigger modes
      TM_NONEXPLICIT = 0, TM_EXPLICIT = 1, TM_PREPARECONTEXTMENU = 2,
      TM_RESULTSELECTED = 3, TM_TABBED = 4;
  // XXX: get this working
  function unique(arr) {
    var i, l = arr.length, res = [];
    for (i = 0; i < l; i += 1) {
      if (res.indexOf(arr[i]) === -1) {
        res.push(arr[i]);
      }
    }
    return res;
  }
  function displayAlertMessage(txt) { 
    FARR.setStrValue("DisplayAlertMessage", txt); 
  }
  function resolveLnkMayBe(path) {
    if (/\.lnk$/i.test(path)) {
      path = FARR.getStrValue("resolvelnk:" + path);
      // XXX: check result?
    }
    return path;
  }
  function findOpenWithKeyword() {
    var i, kwds, owre, ma, uvname;
    kwds = FARR.getStrValue("Search.keywords").split(" ");
    owre = /(openwith[^=]+)/;
    for (i = 0; i < kwds.length; i += 1) {
      ma = owre.exec(kwds[i]);
      if (ma !== null) {
        uvname = ma[1];
        break; // XXX: end on first match
      }
    }
    return uvname;
  }
  function lookupAppStrForName(uvname) {
    var appstr;
    // XXX: should uvname be checked?    
    try {
      appstr = FARR.getStrValue("uservar.Akete." + uvname);
    } catch (e) {
      // XXX: log or feedback?
      return;
    }
    return appstr;    
  }
  function lookupAppStrForPath(path, uvname) {
    var ma, appstr;
    if (!uvname) {
      // XXX: dot inside square brackets escaping?
      ma = /\.([^\.]+)$/i.exec(path);
      // XXX: in general, better to handle an alias string w/ 
      //      $$1-style interpolation, but not doing that yet
      if (ma === null) {
        return;
      }
      uvname = ma[1];
    }
    // XXX: should uvname be checked?
    appstr = lookupAppStrForName(uvname);
    if (!appstr) {
      return;
    }
    return appstr;
  }
  function parseAppPaths(appstr) {
    return appstr.split("|");
  }
  function lookupDefaultPaths() {
    var appstr;
    appstr = lookupAppStrForName("*");
    if (!appstr) {
      return;
    }
    return parseAppPaths(appstr);  
  }
  function appStrIsExt(appstr) {
    // Looks like Wikipedia says following are prohibited in NTFS:
    //   (https://secure.wikimedia.org/wikipedia/en/wiki/Filename)
    //
    //   " * : < > ? \ / |
    //
    // Additionally, file extensions do not contain "."
    if (/["*:<>?\\\/|.]/.test(appstr)) {
      return false;
    }
    return true;
  }
  function appPathIsDefault(path) {
    if (path === "") {
      return true;
    }
    return false;
  }
  function captionFromPath(path, index) {
    var ma, prefix = "";
    ma = /^(.*\\)(([^\\.]+)\.([^.]+))$/i.exec(path);
    if (index && (index <= 9)) {
      prefix = "&" + index + " ";
    }
    if (ma === null) {
      // XXX: somehow didn't work out...
      return prefix + "Open with " + path;
    }
    return prefix + "Open with " + ma[2] + " (" + ma[1] + ")";
  }
  function buildMenuItemString(params) {
    var i, mistr = "type=item";
    for (i in params) {
      if (params.hasOwnProperty(i)) {
        mistr += "|" + i + "=" + params[i];
      }
    }
    return mistr;
  }
  function handleContextMenu(params) {
    var path, entrytype,
        i,
        appstr,
        apppaths, defpaths, apppath, uvname,
        captionstr, menuitemstr, launchstr;
    path = params.path;
    if (!path) {
      return;
    }
    entrytype = params.entrytype;
    if (!entrytype) {
      return;
    }
    switch (entrytype) {
      case FILE:
        path = resolveLnkMayBe(path);
        appstr = lookupAppStrForPath(path);
        defpaths = lookupDefaultPaths();
        if (appstr) {
          if (appStrIsExt(appstr)) {              
            appstr = lookupAppStrForName(appstr);
            if (!appstr) {
              // XXX: failure -- feedback to user?
              return;
            }
          }
          apppaths = parseAppPaths(appstr);
        } else {
          apppaths = [];
        }
        if (defpaths) {
          apppaths = apppaths.concat(defpaths);
        }
        // XXX
        //apppaths = unique(apppaths);
        // XXX: check whether path makes sense?
        for (i = 0; i < apppaths.length; i += 1) {
          apppath = apppaths[i];
          if (appPathIsDefault(apppath)) {
            continue;
          }
          // XXX: check whether apppath makes sense?
          captionstr = captionFromPath(apppath, i + 1);
          launchstr = apppath + " " + "\"" + path + "\"";
          menuitemstr = 
            buildMenuItemString({caption: captionstr,
                                 hint: apppath, // XXX
                                 icon: apppath,
                                 launch: launchstr});
          FARR.setStrValue("addmenu.contextmenu", menuitemstr);
        }
        return;
      default:
        return;
    }
    return;
  }
  function handleTrigger(params) {
    var path, entrytype,
        i,
        appstr,
        apppaths, apppath, uvname,
        launchstr;
    path = params.path;
    if (!path) {
      return;
    }
    entrytype = params.entrytype;
    if (!entrytype) {
      return;
    }
    switch (entrytype) {
      case FILE:
      /*
         The theory:

           Try to resolve shortcuts to operate on non-shortcuts.  This seems 
           more likely to be what a user might want :)

           Look for any +openwith<x> kerywords in the query.  (Assuming here 
           that few people use file extensions that are of the form 
           "openwith<x>".)  If there is an appropriate keyword, will try to 
           use this to determine what application to "open with".  (This 
           overrides the default behavior (described below) so perhaps it 
           can reasonably be compared to command line parameters overriding 
           configuration file options.)

           If no +openwith<x> keywords are found, try to use the (possibly 
           shortcut-resolved) file's extension to determine what application 
           to "open with".

           There are two sorts of values which can appear as configuration 
           values in the user variables section for this plugin:

             1) A list of paths (plus some tricks)

             2) A file extension

           The list of paths is represented as a single string, where the 
           paths are concatenated together using the vertical bar (or pipe) 
           character.  (If the first character of the single string is a 
           vertical bar, no launching is attempted.  Count a single path as a 
           degenerate case of a list.)  Some examples (the parenthesized 
           numbers are not part of the configuration -- they exist to 
           facilitate further discussion):

             D:\Apps\MyApp.exe                                        (1)
             D:\Apps\MyApp.exe|D:\Apps\TheApp.exe                     (2)
             |D:\Apps\MyApp.exe|D:\Apps\TheApp.exe                    (3)

           The file extension is represented as-is.  Note that file extensions 
           do NOT include the period character.  Some examples:

             txt                                                      (4)
             doc
             exe~

           Case (1) is handled in the obvious manner -- just use the path 
           in question as the application to "open with".

           Case (2) is handled by using the first path in the list of paths.

           Case (3) is handled by not handling it -- i.e. the plugin forgoes 
           handling (perhaps FARR ends up handling).

           Case (4) is handled by making an attempt to look for 
           configuration information matching the extension and if successful
           trying to handle based on cases (1), (2), or (3).  Note that this 
           "indirection" is only performed once -- this simplifies the 
           implementation (e.g. not having to consider cycles) and encourages 
           users to keep simpler configurations ;)

         In practice:

           Some testing has been done and so far it seems to work...
      */
        path = resolveLnkMayBe(path);
        // there might not be an openwith<x> keyword, but that's ok
        uvname = findOpenWithKeyword();
        appstr = lookupAppStrForPath(path, uvname);
        if (appstr) {
          if (appStrIsExt(appstr)) {              
            appstr = lookupAppStrForName(appstr);
            if (!appstr) {
              // XXX: failure -- feedback to user?
              return;
            }
          }
          // XXX
          //apppaths = unique(parseAppPaths(appstr));
          apppaths = parseAppPaths(appstr);
          // first one in the list is the default unless it is *
          apppath = apppaths[0];
          if (appPathIsDefault(apppath)) {
            return;
          }
          // XXX: check whether apppath and path make sense?
          launchstr = apppath + " " + "\"" + path + "\"";
          FARR.setStrValue("launch", launchstr);
          return TRIGGER_HANDLED + TRIGGER_CLOSE;
        }
        return;
        //break;
      default:
        return;
    }
  }
  // for onProcessTriggerV2
  function optv2(path, title, groupname, pluginid, thispluginid, 
                 score, entrytype, args, triggermode) {
    switch (triggermode) {
      case TM_TABBED:
        return;
      case TM_RESULTSELECTED:
        return;
      case TM_PREPARECONTEXTMENU:
        return handleContextMenu({path: path, 
                                  entrytype: entrytype});
      case TM_EXPLICIT:
        // XXX: when does this happen?  
        // XXX: fall-through atm
        //return;
      case TM_NONEXPLICIT:
        return handleTrigger({path: path, 
                              entrytype: entrytype});
      default:
        displayAlertMessage("Unrecognized triggermode: " + triggermode);
        // XXX: log?
        return;
    }
    return;
  }
  // for onSetStrValue()
  function ossv(name, value) { 
    if (name === "pcommand") {
      // XXX: a pcommand for checking configuration sanity
      if (value === "akete lint") {
        // XXX: implement
      }
      // XXX: should not get here 
      //pu.reportError2("unrecognized value for pcommand: " + value);
    } else {
      // XXX: commands that we don't handle
      //pu.reportError2("unrecognized name for onSetStrValue: " + name);
    }
    return false;     
  }
  return [optv2, ossv];
} ());
// defined entry points
var onProcessTriggerV2 = dan[0],
    onSetStrValue = dan[1];
    
// jslint complains, but mdc documentation on delete suggests this should work
delete dan;

// Local Variables:
// c-basic-offset: 2
// End:
